#!/usr/local/bin/perl
#
# $Id: install.pl,v 1.1 2000/01/27 00:43:13 tim Exp $#
#
# Purpose: Install MrSID Image Server <15.12.1999 wkallander>

system("clear");


######################################################
# Warn before installing
######################################################
print <<INST_WARN;
This program will install version 2.2 of the MrSID Image Server 
from LizardTech, Inc..

You must be logged in as "root" and located in the directory housing
the installation programs to complete this installation.

This program has the following system dependencies:

1.  Perl version 5.004 or later must be installed
2.  The Apache Web Server version 1.3 must be installed
3.  Solaris version 2.6 or Linux v. 2.x must be installed

CONTINUE? [Y/N]
INST_WARN
&Continue;


######################################################
# Show License
######################################################
print <<LIC_WARN;
In order to install the MrSID Image Server, 
the LizardTech viewing application license must be accepted.

Press <enter> to view the license.
LIC_WARN

$ans = (<STDIN>);
&License;

######################################################
# Warn before Configuring
######################################################
#print <<CONF_WARN;
#You will now be asked some questions for configuration purposes.

#Press <enter> to continue.


#CONF_WARN
#$ans = (<STDIN>);
# system("clear");
# open (STDERR, ">&STDOUT");
# system("pwd>doc.tmp");
# $whereami = system("pwd");
# chomp($whereami);


######################################################
# Get the HTDOCS dir
######################################################
print <<PATH_DIRS;
This installation requires you to enter the absolute path to the
directory in which you wish to install the Image Server program 
(e.g.,"/usr/local/httpd/htdocs"). If you are unsure of this path, 
exit now, check the path, and run the installation program again.

PATH_DIRS

$httpd_path = "/export/home/httpd/html";
print "press <enter> when finished\n\n";
print "DocumentRoot: ->";
$httpd_path = (<STDIN>);
chomp($httpd_path);

$rc = opendir(DIR, "$httpd_path");
while (!$rc) {
	print "Error: Directory does not exist.  ";
	print "Please specify the HTDOCS directory from which ";
	print "Apache is serving.\n";
	print "(press <enter> when finished)\n";
	print "DocumentRoot :->";
	$httpd_path = (<STDIN>);
	chomp($httpd_path);

	$rc = opendir(DIR, "$httpd_path");
}


### Trim off trailing slash if applicable
@path = split ("/", $httpd_path);
$ans = $httpd_path[$#ans];
if ($ans eq "") { 
	chomp($httpd_path); 
}



######################################################
# Unpack the distribution
######################################################
print "Opening distribution...\n";
system("uncompress mrsid_server.tar.Z") ;
	# or warn "Could not find compressed file, trying tar file.\n";

system("cp ./mrsid_server.tar $httpd_path");
print "Installing...\n";

chdir("$httpd_path");
system("tar -xvf ./mrsid_server.tar");
	# or die "Could not find distribution file, giving up...\n";
system("rm -rf $httpd_path/mrsid_server.tar");

closedir(DIR);

print "\nConfiguring Permissions...\n";

######################################################
# Configure perl scripts
######################################################
# open(CONFIG, ">>$httpd_path/mis2/bin/config.pl");
# print CONFIG "# Absolute path on disk where the mrsid server is installed\n";
# print CONFIG "# example: $mrsid_server = \"/export/home/httpd/html/\";\n";
# print CONFIG "\$mrsid_server = \"$httpd_path\";\n";
# print CONFIG "\n";
# print CONFIG "# Web path to the mrsid_server home defined above:\n";
# print CONFIG "# ex: if you access it from http://www.something.com/mrsid/\n";
# print CONFIG "# then the URI would be \"/mrsid\"\n";
# print CONFIG "\$URI = \"mis2\";\n\n";
# print CONFIG "#########################################################\n";
# print CONFIG "# End of mainline\n";
# print CONFIG "#########################################################\n";
# close(CONFIG);


######################################################
# Assign ownerships and permissions
######################################################
system("chown -R root:root $httpd_path/mrsid");
print "chown -R root:root $httpd_path/mrsid\n";
system("chmod -R 644 $httpd_path/mrsid");
print "chmod -R 644 $httpd_path/mrsid\n";
system("chown nobody:nobody $httpd_path/mrsid");
print "chown nobody:nobody $httpd_path/mrsid\n";
system("chown nobody.nobody $httpd_path/mrsid/bin");
print "chown nobody.nobody $httpd_path/mrsid/bin\n";
system("chmod 755 $httpd_path/mrsid");
print "chmod 755 $httpd_path/mrsid\n";
system("chmod 755 $httpd_path/mrsid/index.pl");
print "chmod 755 $httpd_path/mrsid/index.pl\n";
system("chown -R nobody:nobody $httpd_path/mrsid/mrsid_images");
print "chown -R nobody:nobody $httpd_path/mrsid/mrsid_images\n";
system("chmod 755 $httpd_path/mrsid/mrsid_images");
print "chmod 755 $httpd_path/mrsid/mrsid_images\n";
system("chmod 755 $httpd_path/mrsid/mrsid_images/sample");
print "chmod 755 $httpd_path/mrsid/mrsid_images/sample\n";
system("chown -R nobody:nobody $httpd_path/mrsid/sample");
print "chown -R nobody:nobody $httpd_path/mrsid/sample\n";
system("chmod 755 $httpd_path/mrsid/sample");
print "chmod 755 $httpd_path/mrsid/sample\n";
system("chmod 755 $httpd_path/mrsid/sample/index.pl");
print "chmod 755 $httpd_path/mrsid/sample/index.pl\n";
system("chmod 755 $httpd_path/mrsid/bin");
print "chmod 755 $httpd_path/mrsid/bin\n";
system("chmod 755 $httpd_path/mrsid/bin/*.pl");
print "chmod 755 $httpd_path/mrsid/bin/*.pl\n";
system("chmod 755 $httpd_path/mrsid/bin/*.cgi");
print "chmod 755 $httpd_path/mrsid/bin/*.cgi\n";
system("chmod 755 $httpd_path/mrsid/bin/mrsid_extract");
print "chmod 755 $httpd_path/mrsid/bin/mrsid_extract\n";
system("chmod 755 $httpd_path/mrsid/bin/mrsid_retrieve");
print "chmod 755 $httpd_path/mrsid/bin/mrsid_retrieve\n";
system("chmod 755 $httpd_path/mrsid/bin/images");
print "chmod 755 $httpd_path/mrsid/bin/images\n";
system("chmod 755 $httpd_path/mrsid/bin/template");
print "chmod 755 $httpd_path/mrsid/bin/template\n";
system("chmod 755 $httpd_path/mrsid/bin/template/bottom");
print "chmod 755 $httpd_path/mrsid/bin/template/bottom\n";
system("chmod 755 $httpd_path/mrsid/bin/template/left");
print "chmod 755 $httpd_path/mrsid/bin/template/left\n";
system("chmod 755 $httpd_path/mrsid/bin/template/single");
print "chmod 755 $httpd_path/mrsid/bin/template/single\n";
system("chmod 755 $httpd_path/mrsid/bin/template/top");
print "chmod 755 $httpd_path/mrsid/bin/template/top\n";
system("chmod 755 $httpd_path/mrsid/admin");
print "chmod 755 $httpd_path/mrsid/admin\n";
system("chmod 755 $httpd_path/mrsid/admin/*.pl");
print "chmod 755 $httpd_path/mrsid/admin/*.pl\n";
system("chmod 755 $httpd_path/mrsid/admin/*.cgi");
print "chmod 755 $httpd_path/mrsid/admin/*.cgi\n";
system("chmod 755 $httpd_path/mrsid/admin/add_icon");
print "chmod 755 $httpd_path/mrsid/admin/add_icon\n";
system("chmod 755 $httpd_path/mrsid/admin/add_image");
print "chmod 755 $httpd_path/mrsid/admin/add_image\n";
system("chmod 755 $httpd_path/mrsid/admin/admin_home");
print "chmod 755 $httpd_path/mrsid/admin/admin_home\n";
system("chmod 755 $httpd_path/mrsid/admin/edit_cat");
print "chmod 755 $httpd_path/mrsid/admin/edit_cat\n";
system("chmod 755 $httpd_path/mrsid/admin/edit_image");
print "chmod 755 $httpd_path/mrsid/admin/edit_image\n";
system("chmod 755 $httpd_path/mrsid/admin/images");
print "chmod 755 $httpd_path/mrsid/admin/images\n";
system("chmod 755 $httpd_path/mrsid/admin/new_cat");
print "chmod 755 $httpd_path/mrsid/admin/new_cat\n";
system("chmod 755 $httpd_path/mrsid/admin/add_watermark");
print "chmod 755 $httpd_path/mrsid/admin/add_watermark\n";
system("chmod 755 $httpd_path/mrsid/docs");
print "chmod 755 $httpd_path/mrsid/docs\n";
system("chmod 755 $httpd_path/mrsid/docs/java");
print "chmod 755 &httpd_path/mrsid/docs/java\n";
system("chmod 755 $httpd_path/mrsid/docs/images");
print "chmod 755 $httpd_path/mrsid/docs/images\n";
system("chmod 755 $httpd_path/mrsid/docs/mac");
print "chmod 755 $httpd_path/mrsid/docs/mac\n";
system("chmod 755 $httpd_path/mrsid/docs/mac/images");
print "chmod 755 $httpd_path/mrsid/docs/mac/images\n";
system("chmod 755 $httpd_path/mrsid/docs/win");
print "chmod 755 $httpd_path/mrsid/docs/win\n";
system("chmod 755 $httpd_path/mrsid/docs/win/images");
print "chmod 755 $httpd_path/mrsid/docs/win/images\n";
system("chmod 755 $httpd_path/mrsid/help");
print "chmod 755 $httpd_path/mrsid/help\n";
system("chmod 755 $httpd_path/mrsid/help/images");
print "chmod 755 $httpd_path/mrsid/help/images\n";



######################################################
# Readme?
######################################################
#print "Display the Readme file now? [Y/N].\n";
#&DispReadMe;

#system("clear");
print <<SUCCESS;



#####################################################
###############    CONGRATULATIONS    ###############
#####################################################
#                                                   #
# The MrSID Image Server 2.2                        #
# has been successfully installed.                  #
#                                                   #
# Documentation for MrSID Image Server 2.2          #
# can be found at:                                  #
#     http://yourdomain/mrsid/help                  #
#                                                   #
# Administration for MrSID Image Server 2.2         #
# can be found at:                                  #
#     http://yourdomain/mrsid/admin                 #
#                                                   #
# Please note:                                      #
# If you have installed the Image Server in a       #
# directory other than your root html or htdocs     #
# directory, you will need to edit the "\$URI"       #
# variable on line 14 of the config.pl script       #
# (located in mrsid/bin).                           #
#####################################################



SUCCESS

exit (0);
######################################################
# End of mainline
######################################################


######################################################
# User selection validation
######################################################
sub Continue {
	$ans = (<STDIN>);
	chomp($ans);
	if($ans eq "y" || $ans eq "Y") {
		system("clear");
		print "Continuing MrSID Image Server 2.2 Installation...\n\n";
	} else {
		system("clear");
		print "MrSID Image Server 2.2 Installation canceled.\n\n\n\n";
		exit(0);
	}
}


######################################################
# Create a readme file for display
######################################################
sub DispReadMe {

	$ans = (<STDIN>);
	chomp($ans);
	if($ans eq "y" || $ans eq "Y") {
		system("clear");
		system("more -c $httpd_path/mis2/README.txt");
	} 
}


######################################################
# Create a license for display
######################################################
sub License {
	
	# Open a file handle and write out the text.
	open(OUT, "+>mrsid_license.txt");
	print OUT<<LICENSE_END;
Computer Software License Agreement for MrSID Image Server (MIS 2.2)

NOTICE TO USER: THIS IS A CONTRACT

LizardTech is willing to license the enclosed Software and Related Materials 
to You only on the condition that You accept all of the terms and conditions 
contained in this License Agreement. Please read the terms and conditions 
carefully before installing or using the software. By installing or using the 
Software, You are indicating Your acceptance of the LizardTech software license 
Agreement. If You do not agree to the terms of this Agreement, LizardTech is 
unwilling to license the Software to You for any purpose.

1. Scope of Permitted Use. In this Agreement, "Software" shall mean the machine
readable software programs and associated files known as MrSID Image Server 
(MIS 2.2), any modified version, upgrades or other copies of such programs and 
files, and any associated media and printed materials. You have the nonexclusive, 
nontransferable right to install and use the Software on one or more central 
processing unit(s) (which may include a network server) in Your own facilities. 
In addition, You may make one (1) copy of the Software, for nonproductive backup 
purposes ONLY, which is not to be installed on any machine. To such permissible 
copy of the Software, You must affix a permanent label stating the following:

MrSID Image Server (MIS 2.2) is property of LizardTech. Copyright (c) 1998-99, 
LizardTech, Inc., 1008 Western Ave., Suite 200, Seattle, WA 98104. All rights 
reserved. U.S. Patent No. 5,710,835. Foreign Patents Pending. Duplication 
prohibited without the express written consent of LizardTech. Use permitted 
only under license from LizardTech.

Licensee shall not sell, rent, sublicense, lend or provide unlicensed third 
parties access to any version(s) of the Software or Related Materials, or 
Licensee's rights under this Agreement.

2. Proprietary Rights. The Software is owned by LizardTech and/or its suppliers 
and You acknowledge that the structure, organization and/or code to the Software 
is/are the valuable trade secret(s) of LizardTech and is/are protected by United 
States Copyright Law and International Treaty provisions. The Software is protected 
by U.S. Patent No. 5,710,835. Foreign Patents Pending. You agree to hold such trade 
secret(s) in confidence. You further agree not to translate, decompile, disassemble, 
modify, reverse engineer, or otherwise attempt to discover the source code of the 
Software, in whole or in part.

3. No Other Rights. LizardTech retains title and ownership to any and all copies 
of the Software whether transmitted electronically or recorded as diskette copies 
and all subsequent copies of the Software, regardless of the form or media in or 
on which the original and other copies may exist. Except as expressly stated herein, 
this Agreement does not grant You any rights to patents, copyrights, trade secrets, 
trademarks or any other rights with respect to the Software. 

4. Term. This Agreement is effective until terminated. This Agreement shall 
terminate automatically upon failure by Licensee to comply with any of its terms. 
Upon any such termination You must destroy the original and any copies of the Software . 
However, You agree that any provisions of this Agreement that operate to protect 
LizardTech shall remain in force.

5. LIMITED WARRANTY. THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTY
OF ANY KIND. LIZARDTECH AND ITS SUPPLIERS DO NOT AND CANNOT WARRANT THE PERFORMANCE 
OR RESULTS YOU MAY OBTAIN BY USE OR INABILITY TO USE THE SOFTWARE OR THE DOCUMENTATION. 
LIZARDTECH MAKES NO WARRANTIES, EXPRESS OR IMPLIED AS TO NON-INFRINGEMENT OF THIRD PARTY 
RIGHTS, MERCHANTABILITY, OR FITNESS FOR ANY PARTICULAR PURPOSE.

During the term of this license, Your only remedy for any problems with the Software 
will be to obtain a replacement copy from LizardTech at LizardTech's option. YOU AGREE 
THESE ARE YOUR ONLY REMEDIES EVEN IF THEY FAIL OF THEIR ESSENTIAL PURPOSE(S).

IN NO EVENT SHALL LIZARDTECH BE LIABLE TO YOU FOR ANY CONSEQUENTIAL OR INCIDENTAL, 
INDIRECT, SPECIAL, OR PUNITIVE DAMAGES, INCLUDING ANY LOST PROFITS OR OPPORTUNITIES, 
EVEN IF A LIZARDTECH REPRESENTATIVE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

Some states may not allow the above exclusion or limitation of warranties, remedies 
or damages, so the above exclusions or limitations may not apply to You. This warranty 
gives You specific legal rights. You may have other rights which vary from state to state 
or province to province. For further warranty information, contact LizardTech.

6. WARNING. This Software is not designed nor tested for a level of reliability suitable 
for use in any information system the failure of which can reasonably be expected to cause 
personal injury. The Software contains bugs and inaccuracies and You can expect incorrect 
results, errors, and anomalies under normal use. You agree to take precautions to offset 
such risks such as to maintain full backups of storage media and to not use the Software 
where personal injury or property damage may result. 

7. Product Support. No Product support is included with this product. You may obtain 
help information publicly available on the LizardTech Website, if applicable. If 
LizardTech offers maintenance or support contracts for this product, You will receive 
technical support by telephone and/or e-mail if You pay for maintenance and support 
at LizardTech's then applicable rate for the period.

8. Government Reserved Rights. Patented Technology incorporated in the Software was 
developed in part through a project at the Los Alamos National Laboratory (LANL) funded 
by the U.S. Government, managed under contract by the Regents of the University 
of California (University). The MrSID Technology is under exclusive commercial license 
to LizardTech. The U.S. Government and the University have certain reserved rights in 
the Technology as set forth in this Agreement, including:

(a) Unless required by law, the use of the name "the University of California" 
or the name of any facility or campus of the University of California in connection 
with Your use of the Software or any other aspect of this Agreement is expressly prohibited.

(b) The U.S. Government has a non-exclusive, nontransferable, irrevocable, paid-up 
license to practice or have practiced throughout the world, for or on behalf of the 
United States, inventions covered by the University's Patent Rights, and has other 
rights under 35 U.S.C.  200-212 and applicable implementing regulations and under 
the U.S. Department of Energy (DOE)Assignment and Confirmatory License through which 
the DOE's rights in the Technology were assigned to the University.

(c) Under 35 U.S.C.  203, the DOE has the right to require LizardTech to grant a 
non-exclusive, partially exclusive or exclusive license under the Patent Rights in 
any field of use to a responsible applicant(s) upon terms reasonable under the 
circumstances, if LizardTech does not adequately attempt to commercialize the MrSID 
Technology. See 37 CFR 401.6.

(d) LizardTech maintains a discount program for sales of software products incorporating 
the licensed technology to the U.S. Government or any agency thereof or any U.S. 
Government contractor who certifies that its purchase of such software is for or 
on behalf of the U.S. Government.

(e) Should LizardTech's rights in the MrSID Technology under its license with the 
University for any reason terminate during the term of this Agreement, such event 
will automatically operate as an assignment by LizardTech to the University of all 
LizardTech's rights, title, and interest in this Agreement. In such case, if You are 
not in default of the terms and conditions herein, You may continue to use the Software 
under the terms of this Agreement. All provisions for the protection of LizardTech 
would then protect the University.

(f) The University makes no warranty or representation as to the validity or scope 
of its Patent Rights, nor that LizardTech software to the extent it incorporates the 
patented technology will not infringe any patent or other proprietary right and has no
obligation to bring or prosecute any actions for patent infringement to protect Your 
use of the Software. The University has no obligation to furnish any know-how, 
technical assistance, or technical data to You.

9. Notice to Government End Users. If this Software is acquired by or on behalf 
of any unit or agency of the United States Government this provision applies. 
This Software: (a) is a trade secret of LizardTech for all purposes of the Freedom 
of Information Act; (b) is provided with RESTRICTED RIGHTS in accordance with 
subparagraphs (c)(1) and (2) of the Commercial Computer Software-Restricted Rights 
Clause at 48 CFR 52.227-19; (c) in all respects is proprietary data belonging solely 
to LizardTech; and (d) all rights are reserved under the copyright laws of the 
United States. For units of the Department of Defense (DoD), this Software is 
licensed only with "Restricted Rights" as set forth in subparagraph (c)(1)(ii) 
of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013. 
Government users other than under a DoD or GSA contract are notified that use of this 
Software is subject to restrictions that are the same as or similar to those set 
forth above.

10. Governing Law. This Agreement will be governed by the laws in force in the State 
of California, U.S.A. This Agreement will not be governed by the United Nations 
Convention on Contracts for the International Sale of Goods, the application of 
which is expressly excluded.

11. Export Control. You agree that the Software will not be shipped, transferred, 
or exported or reexported into any country or used in any manner prohibited by the 
United States Export Administration Act or any other export laws, restrictions, or 
regulations. Specifically, and without limitation, You agree that the Software will 
not be downloaded or otherwise exported or reexported to (or to a national or 
resident of) Cuba, Iraq, Libya, Sudan, North Korea, Iran, Syria, the Federal 
Republic of Yugoslavia  (Serbia or Montenegro) or any other country or person to 
which the United States has embargoed trade.

12. Entire Agreement. You acknowledge that You have read this Agreement, understand 
it and that it is the complete and exclusive statement of Your Agreement with LizardTech 
which supersedes any prior Agreement, oral or written, between LizardTech and You.

No variation of the terms of this Agreement will be enforceable against LizardTech 
unless LizardTech gives its express consent, in writing signed by an officer of LizardTech.

Copyright (c) 2000 LizardTech, Inc., 1008 Western Ave., Suite 200, Seattle, WA 98104.
All Rights Reserved. 

MrSID and LizardTech are trademarks of LizardTech, Inc. Unauthorized use prohibited.

LizardTech Beta Software License
LICENSE_END
	close(OUT);	


	$rc = system("more -c ./mrsid_license.txt");
	if($rc != 0) {
		print "Could not display license, please obtain a new copy of the ";
		print "MrSID Image Server distribution from LizardTech, since this one ";
		print "appears to have been corrupted.\n";
		exit(0);
	} else {
		print "\n\nDO YOU ACCEPT THIS LICENSE? [Y/N]";
		&Continue;
	}
}
######################################################
# End of Program
######################################################
